# Generated by parse_spec.py
# Do not modify
import numpy as np

header = [
    ("sFileID", "S4"),
    ("fVersionNo", "f4"),
    ("lFileHeaderLength", "i4"),
    ("sCountry", "S30"),
    ("sProvince", "S20"),
    ("sStation", "S40"),
    ("sStationNumber", "S10"),
    ("sRadarType", "S20"),
    ("sLongitude", "S16"),
    ("sLatitude", "S16"),
    ("lLongitudeValue", "i4"),
    ("lLatitudeValue", "i4"),
    ("lHeight", "i4"),
    ("shMaxAngle", "i2"),
    ("shOptiAngle", "i2"),
    ("lAntennaG", "i4"),
    ("usBeamH", "u2"),
    ("usBeamL", "u2"),
    ("ucPolarization", "B"),
    ("usSidelobe", "u2"),
    ("lPower", "i4"),
    ("lWavelength", "i4"),
    ("usLogA", "u2"),
    ("usLineA", "u2"),
    ("usAGCP", "u2"),
    ("usLogMinPower", "u2"),
    ("usLineMinPower", "u2"),
    ("ucClutterT", "B"),
    ("ucVelocityP", "B"),
    ("ucFilterP", "B"),
    ("ucNoiseT", "B"),
    ("ucSQIT", "B"),
    ("ucIntensityC", "B"),
    ("ucIntensityR", "B"),
]

header_dtype = np.dtype(header)

bin_param = [("sCode", "i2"), ("Begin", "i2"), ("End", "i2"), ("BinLength", "i2")]

bin_param_dtype = np.dtype(bin_param)

layer_param = [
    ("ucDataType", "B"),
    ("ucAmbiguousP", "B"),
    ("usSpeed", "u2"),
    ("usPRF1", "u2"),
    ("usPRF2", "u2"),
    ("usPulseWidth", "u2"),
    ("usMaxV", "u2"),
    ("usMaxL", "u2"),
    ("usZBinWidth", "u2"),
    ("usVBinWidth", "u2"),
    ("usWBinWidth", "u2"),
    ("usZBinNumber", "u2"),
    ("usVBinNumber", "u2"),
    ("usWBinNumber", "u2"),
    ("usRecordNumber", "u2"),
    ("sSwpAngle", "i2"),
    ("cDataForm", "c"),
    ("ulDataBegin", "u4"),
]

layer_param_dtype = np.dtype(layer_param)

observation_param = [
    ("ucType", "B"),
    ("usSYear", "u2"),
    ("ucSMonth", "B"),
    ("ucSDay", "B"),
    ("ucSHour", "B"),
    ("ucSMinute", "B"),
    ("ucSSecond", "B"),
    ("ucTimeP", "B"),
    ("ulSMillisecond", "u4"),
    ("ucCalibration", "B"),
    ("ucIntensityI", "B"),
    ("ucVelocityP", "B"),
    ("usZStartBin", "u2"),
    ("usVStartBin", "u2"),
    ("usWStartBin", "u2"),
    ("LayerInfo", layer_param_dtype, 32),
    ("usRHIA", "u2"),
    ("sRHIL", "i2"),
    ("sRHIH", "i2"),
    ("usEYear", "u2"),
    ("ucEMonth", "B"),
    ("ucEDay", "B"),
    ("ucEHour", "B"),
    ("ucEMinute", "B"),
    ("ucESecond", "B"),
    ("ucETenth", "B"),
    ("usZBinByte", "u2"),
    ("BinRange1", bin_param_dtype, 5),
    ("usVBinByte", "u2"),
    ("BinRange2", bin_param_dtype, 5),
    ("usWBinByte", "u2"),
    ("BinRange3", bin_param_dtype, 5),
]

observation_param_dtype = np.dtype(observation_param)

other_info = [("sStationID", "S2"), ("sScanName", "S10"), ("sSpare", "S550")]

other_info_dtype = np.dtype(other_info)

data_block = [
    ("sElevation", "i2"),
    ("usAzimuth", "u2"),
    ("ucHour", "B"),
    ("ucMinute", "B"),
    ("ucSecond", "B"),
    ("ulMillisecond", "u4"),
    ("ucCorZ", "4096B"),
    ("ucUnZ", "4096B"),
    ("cV", "4096c"),
    ("ucW", "4096B"),
    ("siZDR", "4096i2"),
    ("siPHDP", "4096i2"),
    ("siROHV", "4096i2"),
    ("uKDP", "4096i2"),
]

data_block_dtype = np.dtype(data_block)
